package com.semaphore;

import sun.misc.BASE64Decoder;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;

/**
 * Yes. This is insanely ghetto but I wanted to make this as simple as possible with as few moving parts as possible.
 * </p>
 * Brought to you by:
 * User: semaphore
 * Date: Sep 15, 2009
 * Time: 9:49:29 PM
 */
public class UmbrellaData {
    public static final int version = 222;
    public static final String SUCCESS_PREFIX = "STATUS=0&MESSAGE=SUCCESS&REQUEST_STRING=";

    public static final byte[] HANDSHAKE_RESPONSE_3_1 =
            ("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">\n" +
                    "<html>\n" +
                    " <head>\n" +
                    "  <title>Index of /</title>\n" +
                    " </head>\n" +
                    " <body>\n" +
                    "<h1>Index of /</h1>\n" +
                    "<table><tr><th><img src=\"/icons/blank.gif\" alt=\"[ICO]\"></th><th><a href=\"?C=N;O=D\">Name</a></th><th><a href=\"?C=M;O=A\">Last modified</a></th><th><a href=\"?C=S;O=A\">Size</a></th><th><a href=\"?C=D;O=A\">Description</a></th></tr><tr><th colspan=\"5\"><hr></th></tr>\n" +
                    "<tr><td valign=\"top\"><img src=\"/icons/folder.gif\" alt=\"[DIR]\"></td><td><a href=\"TSS/\">TSS/</a></td><td align=\"right\">14-Sep-2009 23:45  </td><td align=\"right\">  - </td></tr>\n" +
                    "<tr><th colspan=\"5\"><hr></th></tr>\n" +
                    "</table>\n" +
                    "<address>Apache/2.2.11 (Debian) DAV/2 SVN/1.5.1 mod_python/3.3.1 Python/2.5.2 mod_ssl/2.2.11 OpenSSL/0.9.8g mod_transform/0.6.0 Server at gs.apple.com Port 80</address>\n" +
                    "</body></html>").getBytes();

    public static void main(String[] args) {

    }

    public static long decodeEcid(String shsh) {
        BASE64Decoder dec = new BASE64Decoder();
        try {
            byte[] data = dec.decodeBuffer(shsh.replaceAll("\\s", ""));
            ByteBuffer buffer = ByteBuffer.wrap(data);
            buffer = buffer.order(ByteOrder.LITTLE_ENDIAN);
            buffer.position(12);
            return buffer.getLong();
        } catch(Exception e) {
            e.printStackTrace();
        }
        return -1;
    }


    public static String decodeFirstTag(String shsh) {
        BASE64Decoder dec = new BASE64Decoder();
        try {
            byte[] data = dec.decodeBuffer(shsh.replaceAll("\\s", ""));
            ByteBuffer buffer = ByteBuffer.wrap(data);
            byte[] tag = new byte[4];
            buffer.get(tag, 0, 4);
            return new String(tag).trim();
        } catch(Exception e) {
            e.printStackTrace();
        }
        return "";
    }

    public static void backupFile(File file) {
        if(!file.exists())
            return;
        int i = 0;
        File bakFile = new File(file.getAbsolutePath() + "." + i++ + ".bak");
        while(bakFile.exists())
            bakFile = new File(file.getAbsolutePath() + "." + i++ + ".bak");
        fileCopy(file, bakFile);
    }

    public static void fileCopy(File src, File dst) {
        try {
            if(dst.exists())
                dst.delete();
            byte[] bytes = new byte[(int)src.length()];
            FileInputStream fis = new FileInputStream(src);
            fis.read(bytes);
            fis.close();
            FileOutputStream fos = new FileOutputStream(dst);
            fos.write(bytes);
            fos.flush();
            fos.close();
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
}
